## ros-melodic-fmi-adapter 1.0.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(fmi_adapter)


include(ExternalProject)
externalproject_add(FMILibraryProject
  GIT_REPOSITORY https://github.com/modelon-community/fmi-library.git
  GIT_TAG 2.1
  TIMEOUT 60
)
externalproject_get_property(FMILibraryProject INSTALL_DIR)
set(FMILibraryProject_INCLUDE_DIR "${INSTALL_DIR}/src/install/include")
set(FMILibraryProject_LIB_DIR "${INSTALL_DIR}/src/install/lib")


## Compile as C++11, supported in ROS Kinetic and newer
add_compile_options(-std=c++11 -Wall -Wextra)

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS
  roscpp
  std_msgs
)

## System dependencies are found with CMake's conventions
# find_package(Boost REQUIRED COMPONENTS system)


## Uncomment this if the package has a setup.py. This macro ensures
## modules and global scripts declared therein get installed
## See http://ros.org/doc/api/catkin/html/user_guide/setup_dot_py.html
# catkin_python_setup()

################################################
## Declare ROS messages, services and actions ##
################################################

## To declare and build messages, services or actions from within this
## package, follow these steps:
## * Let MSG_DEP_SET be the set of packages whose message types you use in
##   your messages/services/actions (e.g. std_msgs, actionlib_msgs, ...).
## * In the file package.xml:
##   * add a build_depend tag for "message_generation"
##   * add a build_depend and a run_depend tag for each package in MSG_DEP_SET
##   * If MSG_DEP_SET isn't empty the following dependency has been pulled in
##     but can be declared for certainty nonetheless:
##     * add a run_depend tag for "message_runtime"
## * In this file (CMakeLists.txt):
##   * add "message_generation" and every package in MSG_DEP_SET to
##     find_package(catkin REQUIRED COMPONENTS ...)
##   * add "message_runtime" and every package in MSG_DEP_SET to
##     catkin_package(CATKIN_DEPENDS ...)
##   * uncomment the add_*_files sections below as needed
##     and list every .msg/.srv/.action file to be processed
##   * uncomment the generate_messages entry below
##   * add every package in MSG_DEP_SET to generate_messages(DEPENDENCIES ...)

## Generate messages in the 'msg' folder
# add_message_files(
#   FILES
#   Message1.msg
#   Message2.msg
# )

## Generate services in the 'srv' folder
# add_service_files(
#   FILES
#   Service1.srv
#   Service2.srv
# )

## Generate actions in the 'action' folder
# add_action_files(
#   FILES
#   Action1.action
#   Action2.action
# )

## Generate added messages and services with any dependencies listed here
# generate_messages(
#   DEPENDENCIES
#   std_msgs
# )

################################################
## Declare ROS dynamic reconfigure parameters ##
################################################

## To declare and build dynamic reconfigure parameters within this
## package, follow these steps:
## * In the file package.xml:
##   * add a build_depend and a run_depend tag for "dynamic_reconfigure"
## * In this file (CMakeLists.txt):
##   * add "dynamic_reconfigure" to
##     find_package(catkin REQUIRED COMPONENTS ...)
##   * uncomment the "generate_dynamic_reconfigure_options" section below
##     and list every .cfg file to be processed

## Generate dynamic reconfigure parameters in the 'cfg' folder
# generate_dynamic_reconfigure_options(
#   cfg/DynReconf1.cfg
#   cfg/DynReconf2.cfg
# )

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if you package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
  INCLUDE_DIRS include
  LIBRARIES ${PROJECT_NAME}
  CATKIN_DEPENDS roscpp std_msgs
  # DEPENDS system_lib
)

###########
## Build ##
###########

## Specify additional locations of header files
## Your package locations should be listed before other locations
#catkin_lint: ignore_once missing_directory
#catkin_lint: ignore_once external_directory
include_directories(
  include
  SYSTEM ${catkin_INCLUDE_DIRS} ${FMILibraryProject_INCLUDE_DIR}
)

## Declare library from FMILibraryProject. Ensure globally unique name by prepending project name.
add_library(${PROJECT_NAME}_fmilib STATIC IMPORTED)
set_target_properties(${PROJECT_NAME}_fmilib PROPERTIES IMPORTED_LOCATION ${FMILibraryProject_LIB_DIR}/libfmilib.a)


### Set strict compiler settings for all source files, but not for test files due to warnings raised by GTest headers.
set_source_files_properties(
  include/${PROJECT_NAME}/FMIAdapter.h
  src/${PROJECT_NAME}/FMIAdapter.cpp
  src/${PROJECT_NAME}_node.cpp
  PROPERTIES COMPILE_FLAGS "-Wpedantic -Weffc++ -Werror"
)


## Declare a C++ library
add_library(${PROJECT_NAME}
  src/${PROJECT_NAME}/FMIAdapter.cpp
)

## Add cmake target dependencies of the library
## as an example, code may need to be generated before libraries
## either from message generation or dynamic reconfigure
add_dependencies(${PROJECT_NAME} ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS} FMILibraryProject)

## Specify libraries to link a library or executable target against
target_link_libraries(${PROJECT_NAME}
  ${catkin_LIBRARIES}
  ${PROJECT_NAME}_fmilib
  dl
)

## Declare a C++ executable
## With catkin_make all packages are built within a single CMake context
## The recommended prefix ensures that target names across packages don't collide
add_executable(${PROJECT_NAME}_node src/${PROJECT_NAME}_node.cpp)

## Rename C++ executable without prefix
## The above recommended prefix causes long target names, the following renames the
## target back to the shorter version for ease of user use
## e.g. "rosrun someones_pkg node" instead of "rosrun someones_pkg someones_pkg_node"
set_target_properties(${PROJECT_NAME}_node PROPERTIES OUTPUT_NAME node PREFIX "")

## Add cmake target dependencies of the executable
## same as for the library above
add_dependencies(${PROJECT_NAME}_node ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS} FMILibraryProject)

## Specify libraries to link a library or executable target against
target_link_libraries(${PROJECT_NAME}_node
  ${catkin_LIBRARIES}
  ${PROJECT_NAME}_fmilib
  dl
  ${PROJECT_NAME}
)

#############
## Install ##
#############

# all install targets should use catkin DESTINATION variables
# See http://ros.org/doc/api/catkin/html/adv_user_guide/variables.html

## Mark executable scripts (Python etc.) for installation
## in contrast to setup.py, you can choose the destination
# install(PROGRAMS
#   scripts/my_python_script
#   DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
# )

## Mark executables and/or libraries for installation
install(TARGETS ${PROJECT_NAME} ${PROJECT_NAME}_node
   ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
   LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
   RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

## Mark cpp header files for installation
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

## Mark other files for installation (e.g. launch and bag files, etc.)
install(DIRECTORY launch/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch
)

#############
## Testing ##
#############

## Add gtest based cpp test target and link libraries
if(CATKIN_ENABLE_TESTING)
  file(GLOB_RECURSE myTestCppFiles "test/*.cpp")
  set(GTEST_LIBRARY gtest)
  find_package(rostest REQUIRED)
  add_rostest_gtest("${PROJECT_NAME}_test" test/${PROJECT_NAME}.test ${myTestCppFiles})
  target_include_directories("${PROJECT_NAME}_test" PRIVATE "test" SYSTEM PUBLIC ${catkin_INCLUDE_DIRS})
  target_link_libraries("${PROJECT_NAME}_test" ${PROJECT_NAME} ${catkin_LIBRARIES} stdc++ pthread m)
endif()

## Add folders to be run by python nosetests
# catkin_add_nosetests(test)

=== debian/changelog ===
ros-melodic-fmi-adapter (1.0.3-1stretch) stretch; urgency=high

  * Fixed sporadic exception in case of small external steps.
  * Updated to FMILibrary version 2.1 and to new location of FMILibrary sources.
  * Fixed fmuLocation argument for fmi2_import_instantiate.

 -- Ralph Lange <ralph.lange@de.bosch.com>  Wed, 29 Jan 2020 23:00:00 -0000

ros-melodic-fmi-adapter (1.0.2-1stretch) stretch; urgency=high

  * Added parameter to configure update period of fmi_adapter node.
  * Introduced functions for single step and replaced calcUntil with doStepsUntil.
  * Enable automatic use of default experiment step-size from FMU in FMIAdapter ctor.
  * Added function to query default experiment step-size given in the FMU.
  * Added step_size parameter and function to query whether the FMU supports a variable communication step size.

 -- Ralph Lange <ralph.lange@de.bosch.com>  Thu, 11 Oct 2018 22:00:00 -0000

ros-melodic-fmi-adapter (1.0.1-1stretch) stretch; urgency=high

  * Throwing runtime_error in case of failed fmi2 function call.

 -- Ralph Lange <ralph.lange@de.bosch.com>  Sun, 15 Jul 2018 22:00:00 -0000

ros-melodic-fmi-adapter (1.0.0-1stretch) stretch; urgency=high

  * Initial version.

 -- Ralph Lange <ralph.lange@de.bosch.com>  Thu, 12 Jul 2018 22:00:00 -0000

=== debian/control ===
Source: ros-melodic-fmi-adapter
Section: misc
Priority: optional
Maintainer: Ralph Lange <ralph.lange@de.bosch.com>
Build-Depends: debhelper (>= 9.0.0), git, ros-melodic-catkin, ros-melodic-roscpp, ros-melodic-rostest, ros-melodic-std-msgs
Homepage: http://wiki.ros.org/fmi_adapter
Standards-Version: 3.9.2

Package: ros-melodic-fmi-adapter
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-roscpp, ros-melodic-std-msgs
Description: Wraps FMUs for co-simulation

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-fmi-adapter//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install

## ros-melodic-fmi-adapter 1.0.4

=== debian/changelog ===
ros-melodic-fmi-adapter (1.0.4-1bionic) bionic; urgency=high

  * Updated to version 2.2.3 of FMILibrary.

 -- Ralph Lange <ralph.lange@de.bosch.com>  Sun, 21 Mar 2021 23:00:00 -0000

ros-melodic-fmi-adapter (1.0.3-1bionic) bionic; urgency=high

  * Fixed sporadic exception in case of small external steps.
  * Updated to FMILibrary version 2.1 and to new location of FMILibrary sources.
  * Fixed fmuLocation argument for fmi2_import_instantiate.

 -- Ralph Lange <ralph.lange@de.bosch.com>  Wed, 29 Jan 2020 23:00:00 -0000

ros-melodic-fmi-adapter (1.0.2-1bionic) bionic; urgency=high

  * Added parameter to configure update period of fmi_adapter node.
  * Introduced functions for single step and replaced calcUntil with doStepsUntil.
  * Enable automatic use of default experiment step-size from FMU in FMIAdapter ctor.
  * Added function to query default experiment step-size given in the FMU.
  * Added step_size parameter and function to query whether the FMU supports a variable communication step size.

 -- Ralph Lange <ralph.lange@de.bosch.com>  Thu, 11 Oct 2018 22:00:00 -0000

ros-melodic-fmi-adapter (1.0.1-1bionic) bionic; urgency=high

  * Throwing runtime_error in case of failed fmi2 function call.

 -- Ralph Lange <ralph.lange@de.bosch.com>  Sun, 15 Jul 2018 22:00:00 -0000

ros-melodic-fmi-adapter (1.0.0-1bionic) bionic; urgency=high

  * Initial version.

 -- Ralph Lange <ralph.lange@de.bosch.com>  Thu, 12 Jul 2018 22:00:00 -0000
